import React from 'react';
declare type Ta = () => Promise<{
    default: any;
}>;
export interface AsyncComponentProps {
    models: Ta[];
    Component: React.ComponentType<any>;
    componentProps: React.Props<any>;
}
export declare const AsyncComponent: ({ models, Component, componentProps, }: AsyncComponentProps) => JSX.Element;
/**
 * 异步加载组件
 *
 * @param {promise} component 异步加载组件 import()
 * @param {object} options 组件配置
 * @param {array} options.models 当前组件需要的 model
 * @param {object} options.props 当前组件 props
 * @returns
 */
export declare const asyncComponent: (Component: () => Promise<{
    default: React.ComponentType<any>;
}>, options?: Partial<{
    models: AsyncComponentProps['models'];
    props: AsyncComponentProps['componentProps'];
}>) => React.ComponentType<any>;
export {};
