
/** @license React-Enhanced 3.0.0
 *
 * Copyright (c) fezzc, react 无侵入架构增强器.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
            
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var reactRedux = require('react-redux');
var Loading = require('./components/Loading');
var index = require('./utils/index');
var modelRedux = require('model-redux');
var ApiManage = require('api-manage');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var Loading__default = /*#__PURE__*/_interopDefaultLegacy(Loading);
var modelRedux__default = /*#__PURE__*/_interopDefaultLegacy(modelRedux);
var ApiManage__default = /*#__PURE__*/_interopDefaultLegacy(ApiManage);

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

// loading model 名称
var LOADING_MODEL_NAME = 'React-Enhnaced-Loading-Model-' + new Date().getTime(); // 标识分隔符 （函数名以及时间戳）

var splitStr = '--';
var loadingModel = {
  namespace: LOADING_MODEL_NAME,
  state: [],
  reducers: {
    // 删除 标识
    remove: function remove(state, _ref) {
      var payload = _ref.payload;
      return state.filter(function (v) {
        return v !== payload;
      });
    },
    // 删除 指定函数名 标识
    removeDesignation: function removeDesignation(state, _ref2) {
      var payload = _ref2.payload;
      return state.filter(function (v) {
        return !v.startsWith("".concat(payload).concat(splitStr));
      });
    },
    // 设置 标识
    set: function set(state, _ref3) {
      var payload = _ref3.payload;
      return [].concat(_toConsumableArray(state), [payload]);
    }
  }
};

var ReStore = {};
/**
 * 添加储存
 *
 * @param {Record<string, any>} data
 */

var addStore = function addStore(data) {
  Object.entries(data).forEach(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        key = _ref2[0],
        value = _ref2[1];

    Reflect.set(ReStore, key, value);
  });
};
/**
 * 获取储存数据
 *
 * @param {keyof TReStore} key
 */

var getStore = function getStore(key) {
  return Reflect.get(ReStore, key);
};
/**
 * React Enhanced Context
 */

var ReactEnhancedContext = /*#__PURE__*/React__default['default'].createContext(ReStore);
/**
 * 设置 请求loading组件 props
 *
 * @param {Record<keyof RequestLoadingProps['spinnerProps'], any>} data
 */

var setRequestLoadingProps = function setRequestLoadingProps(data) {
  addStore({
    requestLoadingProps: _objectSpread2(_objectSpread2({}, getStore('requestLoadingProps')), data)
  });
};
/**
 * 获取  请求loading组件 props
 *
 *@example
 const request = getRequestLoadingProps()
 */

var getRequestLoadingProps = function getRequestLoadingProps() {
  return getStore('requestLoadingProps');
};

var RequestLoading = /*#__PURE__*/React__default['default'].memo(function RequestLoading(props) {
  var include = props.include,
      exclude = props.exclude,
      visible = props.visible,
      otherProps = _objectWithoutProperties(props, ["include", "exclude", "visible"]);

  var modelState = reactRedux.useSelector(function (store) {
    return Reflect.get(store, LOADING_MODEL_NAME);
  }, reactRedux.shallowEqual);

  var _useContext = React.useContext(ReactEnhancedContext),
      requestLoadingProps = _useContext.requestLoadingProps;

  var loading = React.useMemo(function () {
    var currRequestName = modelState.map(function (v) {
      return v.split(splitStr)[0];
    });
    return index.toArray(include !== null && include !== void 0 ? include : currRequestName.filter(function (v) {
      return !index.toArray(exclude).includes(v);
    })).some(function (v) {
      return currRequestName.includes(v);
    });
  }, [modelState, include, exclude]);
  return /*#__PURE__*/React__default['default'].createElement(Loading__default['default'], _extends({}, otherProps, {
    loading: !(visible !== null && visible !== void 0 ? visible : true) || loading,
    spinnerProps: requestLoadingProps
  }));
});

var AsyncComponent = function AsyncComponent(_ref) {
  var models = _ref.models,
      Component = _ref.Component,
      componentProps = _ref.componentProps;

  var _React$useState = React__default['default'].useState(false),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      rely = _React$useState2[0],
      setRely = _React$useState2[1];

  var _React$useContext = React__default['default'].useContext(ReactEnhancedContext),
      registerModel = _React$useContext.registerModel,
      requestLoadingProps = _React$useContext.requestLoadingProps;

  React__default['default'].useEffect(function () {
    if (models.length) {
      // 注入model
      Promise.all(models.map(function (v) {
        return v();
      })).then(function (data) {
        if (data.length) {
          Object.values(data).forEach(function (v) {
            return registerModel(v["default"]);
          });
          setRely(true);
        }
      });
    } else {
      setRely(true);
    }
  }, []);
  return rely ? /*#__PURE__*/React__default['default'].createElement(React__default['default'].Suspense, {
    fallback: /*#__PURE__*/React__default['default'].createElement(Loading__default['default'], {
      spinnerProps: requestLoadingProps
    })
  }, /*#__PURE__*/React__default['default'].createElement(Component, componentProps)) : /*#__PURE__*/React__default['default'].createElement(Loading__default['default'], {
    spinnerProps: requestLoadingProps
  });
};
/**
 * 异步加载组件
 *
 * @param {promise} component 异步加载组件 import()
 * @param {object} options 组件配置
 * @param {array} options.models 当前组件需要的 model
 * @param {object} options.props 当前组件 props
 * @returns
 */

var asyncComponent = function asyncComponent(Component, options) {
  var LazyComponents = /*#__PURE__*/React__default['default'].lazy(Component);
  return function (props) {
    return /*#__PURE__*/React__default['default'].createElement(AsyncComponent, {
      Component: LazyComponents,
      models: index.toArray((options === null || options === void 0 ? void 0 : options.models) || []),
      componentProps: _objectSpread2(_objectSpread2({}, (options === null || options === void 0 ? void 0 : options.props) || {}), props)
    });
  };
};

var ReactEnhancedProvider = function ReactEnhancedProvider(_ref) {
  var children = _ref.children,
      otherProps = _objectWithoutProperties(_ref, ["children"]);

  return /*#__PURE__*/React__default['default'].createElement(ReactEnhancedContext.Provider, {
    value: ReStore
  }, /*#__PURE__*/React__default['default'].createElement(reactRedux.Provider, _objectSpread2({
    store: Reflect.get(ReStore, 'store')
  }, otherProps), children));
};

var init = function init(_ref) {
  var _apiConfig$hooks, _apiConfig$hooks2;

  var _ref$models = _ref.models,
      models = _ref$models === void 0 ? [] : _ref$models,
      apiConfig = _ref.apiConfig,
      modelConfig = _ref.modelConfig,
      requestLoadingConfig = _ref.requestLoadingConfig;

  var _modelRedux$create = modelRedux__default['default'].create(modelConfig),
      store = _modelRedux$create.store,
      registerModel = _modelRedux$create.registerModel;

  var apiHookStart = apiConfig === null || apiConfig === void 0 ? void 0 : (_apiConfig$hooks = apiConfig.hooks) === null || _apiConfig$hooks === void 0 ? void 0 : _apiConfig$hooks.start;
  var apiHookFinally = apiConfig === null || apiConfig === void 0 ? void 0 : (_apiConfig$hooks2 = apiConfig.hooks) === null || _apiConfig$hooks2 === void 0 ? void 0 : _apiConfig$hooks2["finally"];
  var apiManage = new ApiManage__default['default'](_objectSpread2(_objectSpread2({}, apiConfig), {}, {
    hooks: _objectSpread2(_objectSpread2({}, (apiConfig === null || apiConfig === void 0 ? void 0 : apiConfig.hooks) || {}), {}, {
      start: function start() {
        store.dispatch({
          type: "".concat(LOADING_MODEL_NAME, "/set"),
          payload: Array.prototype.slice.call(arguments).join(splitStr)
        });
        if (typeof apiHookStart === 'function') apiHookStart.apply(void 0, arguments);
      },
      "finally": function _finally() {
        store.dispatch({
          type: "".concat(LOADING_MODEL_NAME, "/remove"),
          payload: Array.prototype.slice.call(arguments).join(splitStr)
        });
        if (typeof apiHookFinally === 'function') apiHookFinally.apply(void 0, arguments);
      }
    })
  }));
  var requestList = apiManage.getService();

  var ReRegisterModel = function ReRegisterModel(data) {
    return registerModel(index.toArray(data).map(function (v) {
      return typeof v === 'function' ? v(requestList) : v;
    }));
  };

  addStore({
    store: store,
    registerModel: ReRegisterModel,
    apiManage: apiManage,
    requestLoadingProps: _objectSpread2({
      fadeIn: 'quarter',
      name: 'wave'
    }, requestLoadingConfig || {})
  });
  [].concat(_toConsumableArray(index.toArray(models)), [loadingModel]).forEach(function (v) {
    ReRegisterModel(v);
  });
  return {
    Provider: ReactEnhancedProvider,
    dispatch: store.dispatch
  };
};

/**
 * 使用 apiManage 包装的 request function
 *
 * @returns {Promise[]}
 */

var useApi = function useApi() {
  var apiList = React.useMemo(function () {
    return ReStore.apiManage.getService();
  }, []);
  return apiList;
};

exports.LOADING_MODEL_NAME = LOADING_MODEL_NAME;
exports.RequestLoading = RequestLoading;
exports.asyncComponent = asyncComponent;
exports.getRequestLoadingProps = getRequestLoadingProps;
exports.init = init;
exports.setRequestLoadingProps = setRequestLoadingProps;
exports.useApi = useApi;
