import React from 'react';
import { RequestLoadingProps } from './RequestLoading';
export declare type TReStore = Partial<{
    store: any;
    registerModel: any;
    apiManage: any;
    requestLoadingProps: RequestLoadingProps['spinnerProps'];
}> & {};
export declare const ReStore: TReStore;
/**
 * 添加储存
 *
 * @param {Record<string, any>} data
 */
export declare const addStore: (data: Record<string, any>) => void;
/**
 * 获取储存数据
 *
 * @param {keyof TReStore} key
 */
export declare const getStore: (key: keyof TReStore) => any;
/**
 * React Enhanced Context
 */
export declare const ReactEnhancedContext: React.Context<Partial<{
    store: any;
    registerModel: any;
    apiManage: any;
    requestLoadingProps: RequestLoadingProps['spinnerProps'];
}>>;
/**
 * 设置 请求loading组件 props
 *
 * @param {Record<keyof RequestLoadingProps['spinnerProps'], any>} data
 */
export declare const setRequestLoadingProps: (data: Record<keyof RequestLoadingProps['spinnerProps'], any>) => void;
/**
 * 获取  请求loading组件 props
 *
 *@example
 const request = getRequestLoadingProps()
 */
export declare const getRequestLoadingProps: () => Record<keyof RequestLoadingProps['spinnerProps'], any>;
